<template>
  <div :class="[ 'registration-wrapper h-100', { 'with-footer': isFooterVisible } ]">
    <RegistrationInstructionAlert v-if="currentHostname === 'gruzi'" />
    <left-form-wrapper
      :title="registrationDone ? 'Спасибо, мы получили ваши данные и сейчас их проверяем' : currentStep.title"
      :is-back="!registrationDone"
      :back-handler="onBack"
      :show-info-message="true"
    >
      <div class="registration-step-counters">
        <div
          class="registration-step-path"
          :style="cssVars"
        />

        <div
          v-for="(step, index) in steps"
          :key="`registration-step-counter-${index}`"
          class="registration-step-counter"
          :class="{
            'registration-step-counter-active': currentStepIndex === index,
            'registration-step-counter-completed': currentStepIndex > index || registrationDone
          }"
        >
          <div v-if="currentStepIndex <= index && !registrationDone">
            {{ index + 1 }}
          </div>

          <div
            v-else
            class="registration-step-counter-completed-icon"
          >
            <svg width="13" height="11" viewBox="0 0 13 11" fill="none">
              <path
                fill-rule="evenodd"
                clip-rule="evenodd"
                d="M12.0999 0.219014C12.5512 0.571967 12.633 1.22662 12.2826 1.68123L5.41107 10.597C5.22559 10.8376 4.94487 10.9845 4.64276 10.9988C4.34066 11.0132 4.04744 10.8937 3.84028 10.6717L0.780807 7.39369C0.389456 6.97438 0.409634 6.31487 0.825877 5.92063C1.24212 5.5264 1.8968 5.54673 2.28816 5.96604L4.51884 8.35608L10.6484 0.40307C10.9987 -0.0515347 11.6486 -0.13394 12.0999 0.219014Z"
              />
            </svg>
          </div>
        </div>
      </div>

      <transition
        name="fadeIn"
        mode="out-in"
      >
        <component
          v-if="!pending && !registrationDone"
          :is="`${currentStep.counter}-step`"
          @changeStep="onChangeStep"
        />

        <div v-if="registrationDone">
          <final />
        </div>
      </transition>

      <div
        v-if="currentStepIndex === 0"
        slot="footer">

        Уже зарегистрированы?
        <router-link :to="{ name: 'login' }">
          Войти
        </router-link>
      </div>
    </left-form-wrapper>

    <ob-modal
      ref="confirmGoToBack"
      title="Хотите прекратить процесс регистрации?"
      size="sm"
      :is-show-controls="true"
      :is-error="true"
      ok-text="Да, прекратить"
      cancel-text="Продолжить"
      @submit="goBack"
    />

    <footer
      v-if="isFooterVisible"
      class="footer"
    >
      ООО “Обоз”. 127015, Москва, Вятская ул, д.27, стр. 13, эт.3, пом. VII, ком. 34,35.
      ИНН 7734397465, ОГРН 1177746011871, КПП 771401001.<br>
      <a href="mailto:info@oboz.com" class="link-style">info@oboz.com</a>, +7 (495) 646-06-03.
      <a
        :href="`https://220919.selcdn.ru/cdn.oboz.com/legal/private_policy_oboz.pdf?h=${uuid.v4()}`"
        class="link-style"
        target="_blank"
      >
        Политика конфиденциальности
      </a>
      и
      <a
        :href="`https://oboz.com/privacy-policy-9999?h=${uuid.v4()}`"
        class="link-style"
        target="_blank"
      >
        Согласие на обработку персональных данных
      </a>
    </footer>
  </div>
</template>

<script>

import { getCookie } from '@/utils/cookie'
import { getTokenData } from '@/tokenData'
import api from '@/api'
import { uuid } from 'vue-uuid'
import LeftFormWrapper from '../../components/LeftFormWrapper/index'
import VueCookie from 'vue-cookie'
import routeMixin from '../../mixins/route-mixin'
import ObModal from 'common-components/src/obComponents/obModal/index'

import FirstStep from './steps/first/index'
import SecondStep from './steps/second'
import ThirdStep from './steps/third'
import FourthStep from './steps/fourth/index'
import Final from './final'
import { mapGetters } from 'vuex'
import RegistrationInstructionAlert from '../../components/RegistrationInstructionAlert'

export default {
  name: 'Registration',
  components: {
    ObModal,
    LeftFormWrapper,
    FirstStep,
    SecondStep,
    ThirdStep,
    FourthStep,
    Final,
    RegistrationInstructionAlert
  },

  mixins: [
    routeMixin
  ],
  computed: {
    ...mapGetters({
      registrationDone: 'entry/registrationDone'
    }),
    currentHostname() {
      return window.location.host.split('gruzi').length > 1 ? 'gruzi': 'oboz'
    },
    currentStep: ({ currentStepIndex, steps }) => steps[currentStepIndex],
    cssVars: ({ currentStepIndex }) => ({ '--step-path-width': `calc(${25 * currentStepIndex}% + ${18 * currentStepIndex + 1}px)` }),
    isFooterVisible: () => window.location.host.split('oboz').length > 1
  },
  data () {
    return {
      uuid,
      currentStepIndex: 0,
      pending: false,
      steps: [
        {
          counter: 'first',
          title: 'Регистрация'
        },
        {
          counter: 'second',
          title: 'Откройте почту'
        },
        {
          counter: 'third',
          title: 'Добро пожаловать!'
        },
        {
          counter: 'fourth',
          title: 'Аккредитация'
        }
      ]
    }
  },
  beforeRouteEnter(to, from, next) {
    next(async vm => {
      vm.pending = true;
      if (getCookie('auth_token')) {
        try {
          const response = await api.registration.auth.status();
          const status = response.participantStatus;

          switch (status) {
            case 'NEW': {
              const tokenData = { ...getTokenData() };
              if (tokenData.contractor_role_code) {
                vm.currentStepIndex = 3;
              } else {
                vm.currentStepIndex = 2;
              }
              break;
            }
            default: {
              vm.$router.replace({ path: '/login' })
            }
          }
        } catch(e) {
          console.log(e)
        }
      }
      vm.pending = false;
    });
  },
  methods: {
    goBack() {
      VueCookie.delete('auth_token');
      VueCookie.delete('refresh_token')
      localStorage.setItem('clear_auth_token', Math.random());
      this.handleBack();
    },

    //Events
    onChangeStep(index) {
      this.currentStepIndex = index;
    },

    onBack() {
      this.$refs.confirmGoToBack.open()
    }
  },
  metaInfo() {
    return {
      meta: [
        { name: 'yandex', content: 'noindex, nofollow' }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .registration-wrapper {
    --footer-height: 0px;

    &.with-footer {
      --footer-height: 50px;
    }
  }

  .left-form-container-wrapper {
    height: calc(100% - var(--footer-height));
  }

  .registration-step-counters {
    display: flex;
    justify-content: space-between;
    position: relative;
    margin-bottom: 30px;
  }

  .registration-step-path {
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    margin: auto;
    height: 2px;
    width: 100%;
    background-image: linear-gradient(to right, $color-grey-border 75%, #fff 0%);
    background-size: 8px 2px;
    background-repeat: repeat-x;

    &::after {
      content: '';
      height: 100%;
      background-image: linear-gradient(to right, $color-green-light 75%, #fff 0%);
      background-size: 8px 2px;
      background-repeat: repeat-x;
      transition: width .3s ease;
      position: absolute;
      left: 0;
      top: 0;
      width: var(--step-path-width);
    }
  }

  .registration-step-counter {
    @include font-mixin(16px, inherit, 700, $color-grey-border, 0.4px);
    width: 36px;
    height: 36px;
    box-sizing: border-box;
    display: flex;
    align-items: center;
    justify-content: center;
    text-align: center;
    border-radius: 50%;
    border: 2px solid $color-grey-border;
    transition: border-color .3s ease, color .3s ease;
    cursor: default;
    background: $background-white;
    position: relative;

    &.registration-step-counter-active {
      color: $color-blue-navy-blue;
      border-color: $color-blue-navy-blue;
    }

    &.registration-step-counter-completed {
      border-color: $color-green-light;
    }
  }

  .registration-step-counter-completed-icon {
    path {
      fill: $color-green-light
    }
  }

  .footer {
    @include font-mixin(12px, 16px, normal, $color-text-base, 0.4px);

    text-align: center;
    padding: 9px 15px;
    height: var(--footer-height);
    background-color: mix(white, $blue-700, 90%);
  }
</style>
